<?php

if ( ( comments_open() || get_comments_number() ) && !post_password_required() ) {

  global $post; ?>

  <!-- comments -->
  <div id="comments" class="comments comments-outer clearfix">
    <div class="kuist-content-size">
      <div class="comments-title"><?php if ( get_comments_number( $post->ID ) == 1 ) { echo get_comments_number( $post->ID ) . esc_html( ' ' . kuist_translation( '_Comment' ) ); } else { echo get_comments_number( $post->ID ) . esc_html( ' ' . kuist_translation( '_Comments' ) ); } ?></div>
      <div class="comments-container">
        <?php if ( get_comments_number( $post->ID ) >= 1 ) {
          echo '<ul class="comments-inner">';
        } ?>
          <?php
          wp_list_comments( array(
            'avatar_size' => 40,
            'max_depth' => 3,
            'style' => 'ul',
            'callback' => 'kuist_setCommentItem',
            'type' => 'all'
          ) );
          ?>
        <?php if ( get_comments_number( $post->ID ) >= 1 ) {
          echo '</ul>';
        } ?>

        <?php if ( get_comment_pages_count() > 1 && get_option( 'page_comments' ) ) { ?>

          <div class="comments-pagenavi clearfix"><?php echo paginate_comments_links( array( 'prev_text' => '<i class="fas fa-chevron-left"></i>', 'next_text' => '<i class="fas fa-chevron-right"></i>' ) ); ?></div>

        <?php } ?>

        <?php
        $req = get_option( 'require_name_email' );
        $aria_req = ( $req ? " aria-required='true'" : '' );

        $fields = array (
          'author' => '<div class="comment-form-name-outer"><label for="author"></label><input placeholder="' . esc_attr( kuist_translation( '_Name' ) ) . ( esc_attr( $req ) ? ' *' : '' ) . '" id="author" name="author" type="text" value="' . esc_attr( $commenter['comment_author'] ) . '" ' . esc_attr( $aria_req ) . ' /></div>',
          'email' => '<div class="comment-form-email-outer"><label for="email"></label><input placeholder="' . esc_attr( kuist_translation( '_Email' ) ) . ( esc_attr( $req ) ? ' *' : '' ) . '" id="email" name="email" ' . 'type="text"' . ' value="' . esc_attr( $commenter['comment_author_email'] ) . '" aria-describedby="email-notes"' . esc_attr( $aria_req ) . ' /></div>',
          'cookies' => '<p class="comment-form-cookies-consent"><input id="wp-comment-cookies-consent" name="wp-comment-cookies-consent" type="checkbox" value="yes"> <label for="wp-comment-cookies-consent">' . esc_html( kuist_translation( '_Cookie' ) ) . '</label></p>',
        );

        $comment_field = '<label for="comment"></label><textarea placeholder="' . esc_attr( kuist_translation( '_Comment' ) ) . '" id="comment" name="comment" aria-describedby="form-allowed-tags" aria-required="true"></textarea>';

        $must_log_in = sprintf( '<a href="%s">' . esc_html( kuist_translation( '_MustBeLogged' ) ) . '</a>', wp_login_url( apply_filters( 'the_permalink', get_permalink() ) ) );

        $logged_in_as = '<p class="logged-in-as">' . sprintf( esc_html( kuist_translation( '_Logged' ) ) . ': <a href="%1$s">%2$s</a> - <a href="%3$s">' . esc_html( kuist_translation( '_LogOut' ) ) . '</a>', get_edit_user_link(), $user_identity, wp_logout_url( apply_filters( 'the_permalink', get_permalink() ) ) ) . '</p>';

        $cancel_reply = esc_html( kuist_translation( '_CancelReply' ) );

        comment_form( array(
          'fields' => $fields,
          'comment_field' => $comment_field,
          'comment_notes_after' => '',
          'comment_notes_before' => '',
          'title_reply_before' => '<div id="reply-title" class="comment-reply-title">+ ',
          'title_reply_after' => '</div>',
          'title_reply' => esc_html( kuist_translation( '_LeaveReply' ) ),
          'title_reply_to' => esc_html( kuist_translation( '_LeaveReply' ) ),
          'cancel_reply_link' => $cancel_reply,
          'label_submit' => esc_html( kuist_translation( '_PostComment' ) ),
          'must_log_in' => $must_log_in,
          'logged_in_as' => $logged_in_as
        ) );
        ?>

      </div>
    </div>
  </div><!-- /comments -->

<?php }

function kuist_setCommentItem( $comment, $args, $depth ) {

  $GLOBALS['comment'] = $comment; ?>

  <li <?php comment_class( 'clearfix' ); ?> id="comment-<?php comment_ID(); ?>">
    <?php if ( get_avatar( $comment ) ) { ?><?php echo get_avatar( $comment, $args['avatar_size'] ); ?><?php } ?>
    <div class="commenter-info">
      <div class="commenter-info-inner">
        <div class="comment-date"><?php printf( '%1$s ' . esc_html( kuist_translation( '_At' ) ) . ' %2$s', get_comment_date(),  get_comment_time() ) ?></div>
        <div class="commenter-name"><?php echo get_comment_author_link(); ?></div>
        <?php if ( !$comment->comment_approved ) { echo '<div class="comment-awaiting">' . esc_html( kuist_translation( '_Awaiting' ) ) . '</div>'; } ?>
      </div>
    </div>
    <div class="comment-text clearfix<?php if ( get_avatar( $comment ) ) { echo ' comment-text-w-a'; } ?>">
      <?php
      comment_text();
      if ( $depth < 3 ) { comment_reply_link( array_merge( $args, array( 'reply_text' => esc_html( kuist_translation( '_Reply' ) ), 'depth' => $depth, 'max_depth' => $args['max_depth'] ) ), $comment->comment_ID); }
      if ( user_can( wp_get_current_user(), 'administrator' ) ) { edit_comment_link( esc_html( kuist_translation( '_Edit' ) ) ); }
      ?>
    </div>

  <?php } ?>
