<!DOCTYPE html>
<html <?php language_attributes(); ?>>
	<head>
		<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
		<meta charset="<?php bloginfo( 'charset' ); ?>">
		<link rel="pingback" href="<?php esc_url( bloginfo( 'pingback_url' ) ); ?>" />
		<?php wp_head(); ?>
	</head>
	<body <?php body_class(); ?>>
		<div class="kuist-stripes"></div>
		<div class="mobile-header clearfix">
			<div class="mobile-logo-outer">
				<div class="mobile-logo-container">
					<a href="<?php echo esc_url( home_url( '/' ) ); ?>">
						<?php $stickyLogoPath = '';
						if ( get_theme_mod( 'kuist_mobile_logo_image' ) ) {
							$stickyLogoPath = get_theme_mod( 'kuist_mobile_logo_image' );
						} else if ( get_theme_mod( 'kuist_logo_image' ) ) {
							$stickyLogoPath = get_theme_mod( 'kuist_logo_image' );
						}
						if ( $stickyLogoPath ) { ?><img alt="<?php echo esc_attr__( 'site-mobile-logo', 'kuist' ); ?>" src="<?php echo esc_url( $stickyLogoPath ); ?>" /><?php } ?>
						<?php if ( !$stickyLogoPath || ( $stickyLogoPath && get_theme_mod( 'kuist_show_logotext', 1 ) ) ) { ?><h1 class="logo-text"><?php bloginfo( 'name' ); ?></h1><?php } ?>
					</a>
				</div>
			</div>
			<?php if ( get_theme_mod( 'kuist_show_header_contact', 1 ) ) { ?>
				<div class="contact-ico-button"><i class="fas fa-map-marker-alt"></i></div>
			<?php } ?>
			<div class="mobile-menu-button"><i class="fas fa-bars"></i></div>
			<div id="touch-menu"></div>
		</div>
		<div class="kuist-img-preloader"><div class="swiper-lazy-preloader"></div></div>
		<div class="site-top clearfix">
			<div class="site-top-container-outer clearfix">
				<div class="site-top-container clearfix">
					<?php get_template_part( 'logo' ); ?><div class="site-logo-outer-handler"></div><?php get_template_part( 'primary-menu' ); ob_start( 'kuist_compress' ); get_template_part( 'contact-icon' ); ob_end_flush(); ?>
				</div>
			</div>
		</div>
		<?php if ( is_page_template( 'templates/works.php' ) || is_tax() ) { ?>
			<div class="hiddenInfo">
				<span id="l_hdr_client"><?php echo esc_html( kuist_translation( '_Client' ) ); ?></span>
				<span id="l_hdr_agency"><?php echo esc_html( kuist_translation( '_Agency' ) ); ?></span>
				<span id="l_hdr_photographer"><?php echo esc_html( kuist_translation( '_Photographer' ) ); ?></span>
				<span id="l_hdr_retoucher"><?php echo esc_html( kuist_translation( '_Retoucher' ) ); ?></span>
				<span id="l_hdr_artist"><?php echo esc_html( kuist_translation( '_Artist' ) ); ?></span>
				<span id="l_hdr_makeup"><?php echo esc_html( kuist_translation( '_MakeUp' ) ); ?></span>
				<span id="l_hdr_date"><?php echo esc_html( kuist_translation( '_Date' ) ); ?></span>
				<span id="l_hdr_other"><?php echo esc_html( kuist_translation( '_Other' ) ); ?></span>
			</div>
			<div id="kuist-mask" class="kuist-mask-hidden"></div>
			<div id="kuist-lightbox" class="kuist-stripes">
				<div class="kuist-lightbox-swiper"><div class="swiper-wrapper"></div></div>
				<div class="kuist-lightbox-title"></div>
				<div class="kuist-lightbox-close"><div class="klc-inner"><?php echo esc_html( kuist_translation( '_Close' ) ); ?></div></div>
				<div class="kuist-lightbox-prev kuist-circle-button"></div>
				<div class="kuist-lightbox-next kuist-circle-button"></div>
				<div class="kuist-lightbox-info"></div>
			</div>
	<?php } ?>
