<?php get_header();

$kuist_archive_title = '';

if ( is_search() ) {

	$search_string = esc_html( get_search_query( false ) );
	if ( strlen( $search_string ) > 20 ) { $search_string = substr( $search_string, 0, 20 ) . '...'; }
	$kuist_archive_title .= $search_string;

} else if ( is_category() ) {

	$kuist_archive_title = single_cat_title( '', false );

} else if ( is_tag() ) {

	$kuist_archive_title = single_tag_title( '', false );

} else if ( is_author() ) {

	the_post();
	$kuist_archive_title .= get_the_author();
	rewind_posts();

} else if ( is_day() ) {

	$kuist_archive_title .= get_the_date();

} else if ( is_month() ) {

	$kuist_archive_title .= get_the_date( 'F Y' );

} else if ( is_year() ) {

	$kuist_archive_title .= get_the_date( 'Y' );

} else if ( is_archive() ) {

	$kuist_archive_title = kuist_translation( '_Archives' );

}

?>

<?php if ( $kuist_archive_title ) { ?>
	<div class="archive-bar"><?php echo wp_kses_post( $kuist_archive_title ); ?></div>
<?php } ?>

<div class="clearfix posts-wrapper">

		<?php

    if ( have_posts() ) {

      while ( have_posts() ) {

        the_post(); ?>

        <div class="<?php echo kuist_apply_columns(); ?>">
          <article <?php post_class( 'clearfix' ); ?>>
            <?php if ( has_post_thumbnail() ) {
    					echo '<a href="' . esc_url( get_the_permalink() ) . '" class="posts-wrapper-img">';
							echo the_post_thumbnail( 'kuist-blog-thumbnail' );
							echo '</a>';
    				} else {
							echo '<a href="' . esc_url( get_the_permalink() ) . '" class="posts-wrapper-woi">';
							echo substr( get_the_title(), 0, 1 );
							echo '</a>';
						} ?>
						<?php if ( get_the_category() ) { get_template_part( 'category-bar' ); } ?>
						<h2 class="post-styleZ-title"><a href="<?php esc_url( the_permalink() ); ?>"><?php if ( is_sticky() && is_home() && !is_paged() ) { ?><i class="fas fa-thumbtack"></i><?php } the_title(); ?></a></h2>
          </article>
        </div>

      <?php }

		} else {

			echo kuist_nothing_found();

		}

		wp_reset_postdata();

		kuist_posts_navigation();

		?>

	</div>

<?php get_footer(); ?>
