jQuery( document ).ready( function( $ ) {

	"use strict";

	/* START */

	var animInt = 0;
	var animInt2 = 0;
	var maskInt = 0;
	var contact_pane_opened = false;
	var categories_pane_opened = false;

	/* Fitvids */
	$( '.to_fit_vids' ).fitVids();
	/* */

	/* Added to avoid iframe confusion on Chrome, Safari and Opera */
	$( 'iframe' ).each( function() {
      this.src = this.src;
  } );
	/* */

	/* Menu Button */
	$( '.mobile-menu-button' ).on( 'click', function() {
		$( '#site-menu' ).slicknav( 'toggle' );
	} );

	$( '.mobile-menu-button' ).toggle(
    function() {
			$( '.mobile-logo-outer' ).addClass( 'mb10' );
			$( '.mobile-logo-container img, .mobile-header h1.logo-text' ).removeClass( 'mlc-closed' ).addClass( 'mlc-opened' );
		},
    function() {
			$( '.mobile-logo-outer' ).removeClass( 'mb10' );
			$( '.mobile-logo-container img, .mobile-header h1.logo-text' ).removeClass( 'mlc-opened' ).addClass( 'mlc-closed' );
		}
	);
	/* */

	/* Apply Slicknav */
	var slicknav_apl = false;
	var slicknav_apl_check = Number( $( '#slicknav_apl' ).html() );
	if ( slicknav_apl_check ) { slicknav_apl = true; }

	$( '#site-menu' ).slicknav( {
		label: '',
		prependTo: '#touch-menu',
		allowParentLinks: slicknav_apl,
		closedSymbol: '<i class="fas fa-angle-right"></i>',
		openedSymbol: '<i class="fas fa-angle-down"></i>',
	} );
	/* */

	/* Submenu Position */
	function kuist_set_submenu_positions() {
		$( '.site-nav li.menu-item-has-children' ).each( function() {
			$( this ).find( 'ul.sub-menu' ).css( 'margin-left', -$( this ).find( 'ul.sub-menu' ).width() + $( this ).width() );
		} );
	}
	setTimeout( kuist_set_submenu_positions, 200 );
	/* */

	/* Passive a style */
	$( '.menu-item-passive' ).find( 'a' ).removeAttr( 'href' );
	/* */

	/* Blog */
	function kuist_blog_item_woi_bg_height() {
		if ( $( '.posts-wrapper-img')[0] ) {
			$( '.posts-wrapper-woi' ).css( 'line-height', $( '.posts-wrapper-img img').height() + 'px' );
		}
	}
	setTimeout( kuist_blog_item_woi_bg_height, 10 );

	$( '.post-navi-prev' ).append( '<div class="pnp-arrow"></div>' );
	$( '.post-navi-next' ).append( '<div class="pnn-arrow"></div>' );
	$( '.page-numbers' ).addClass( 'kuist-circle-button' );
	/* */

	/* Leave a reply */
	$( '.comment-reply-link' ).on( 'click', function() {
		$( '.comment-form' ).css( 'display', 'block' );
		$( '.comment-respond' ).addClass( 'comment-respond-opened' );
	} );

	$( '#cancel-comment-reply-link' ).on( 'click', function() {
		$( '.comment-respond' ).removeClass( 'comment-respond-opened' );
	} );
	$( '<i class="kuist-before-pc fas fa-location-arrow"></i>' ).insertAfter( '#commentform p.form-submit input[type=submit]' );
	/* */

	/* Contact Pane */
	$( '.contact-ico-button' ).on( 'click', function() {
		kuist_contact_pane_toggle();
	} );

	$( '.contact-pane-outer .pane-lens, .contact-pane-outer .pane-close' ).on( 'click', function() {
		kuist_close_contact_pane();
	} );

	function kuist_contact_pane_toggle() {
		if ( contact_pane_opened ) {
			kuist_close_contact_pane();
		} else {
			$( '.contact-pane-outer' ).addClass( 'pane-active' );
			$( 'body, .kuist-categories-icon' ).addClass( 'contact-pane-body-margin' );
			contact_pane_opened = true;
		}
	}

	function kuist_close_contact_pane() {
		$( '.contact-pane-outer' ).removeClass( 'pane-active' );
		$( 'body, .kuist-categories-icon' ).removeClass( 'contact-pane-body-margin' );
		contact_pane_opened = false;
	}
	/* */

	/* Categories Pane */
	$( '.kuist-categories-icon' ).on( 'click', function() {
		kuist_categories_pane_toggle();
	} );

	$( '.categories-pane-outer .pane-lens, .categories-pane-outer .pane-close' ).on( 'click', function() {
		kuist_close_categories_pane();
	} );

	function kuist_categories_pane_toggle() {
		if ( categories_pane_opened ) {
			kuist_close_categories_pane();
		} else {
			$( '.categories-pane-outer' ).addClass( 'pane-active' );
			$( 'body' ).addClass( 'categories-pane-body-margin' );
			$( '.kuist-categories-icon' ).addClass( 'kci-active' );
			categories_pane_opened = true;
		}
	}

	function kuist_close_categories_pane() {
		$( '.categories-pane-outer' ).removeClass( 'pane-active' );
		$( 'body' ).removeClass( 'categories-pane-body-margin' );
		$( '.kuist-categories-icon' ).removeClass( 'kci-active' );
		categories_pane_opened = false;
	}
	/* */

	/* Footer */
	if ( !$( '.assign-menu.footer-nav' ).html() && !$( '.footer-social' ).html() ) {
		$( '.footer-bottom' ).css( 'background-color', 'transparent' );
	}
	/* */

	/* Lightbox */
	var series_first_click = true;
	var series_data_order = 0;
	var max_image_width = 0;
	var max_image_height = 0;

	function kuist_get_miw() {
		if ( $( window ).width() > 640 ) {
			max_image_width = $( window ).width() - 200;
		} else {
			max_image_width = $( window ).width();
		}
		return max_image_width;
	}

	function kuist_get_mih() {
		if ( $( window ).width() > 640 ) {
			max_image_height = $( window ).height() - 100;
		} else {
			max_image_height = $( window ).height();
		}
		return max_image_height;
	}

	var kuist_lightbox_lazy = false;
	var kuist_lightbox_preload = true;
	var kuist_lightbox_datasrc = '';
	var kuist_lightbox_imgclass = 'kuist-swiper-default';
	var kuist_lightbox_preloader = '';
	var kuist_lightbox_image_cap = '';

	if ( $( '#swiper_lazy_check' ).text() == 0 ) { kuist_lightbox_lazy = false; } else { kuist_lightbox_lazy = true; }

	if ( kuist_lightbox_lazy ) {
		kuist_lightbox_preload = false;
		kuist_lightbox_datasrc = 'data-';
		kuist_lightbox_imgclass = 'swiper-lazy';
		kuist_lightbox_preloader = '<div class="swiper-lazy-preloader"></div>';
	}

	var kuist_lightbox_swiper = new Swiper( '.kuist-lightbox-swiper', {
		roundLengths: true,
		centeredSlides: true,
		preloadImages: kuist_lightbox_preload,
	 	lazy: kuist_lightbox_lazy,
	} );

	kuist_lightbox_swiper.on( 'slideChange', function() {
		if ( !series_first_click ) {
			kuist_lightbox_check_navigation();
			if ( !kuist_lightbox_lazy ) { kuist_set_lightbox_all_images_pos(); }
		}
	} );

	kuist_lightbox_swiper.on( 'lazyImageReady', function() {
		kuist_set_lightbox_active_image_pos( kuist_get_miw, kuist_get_mih, $( '.kuist-lightbox-swiper .swiper-slide-active img.swiper-lazy-loaded' ) );
	} );

	function kuist_lightbox_check_first_navigation() {
		$( '.kuist-lightbox-prev, .kuist-lightbox-next' ).hide();
		if ( kuist_lightbox_swiper.activeIndex != 0 ) {
			$( '.kuist-lightbox-prev' ).show();
		}
		if ( kuist_lightbox_swiper.activeIndex != $( '.kuist-lightbox-swiper' ).find( '.swiper-slide ' ).length - 1 ) {
			$( '.kuist-lightbox-next' ).show();
		}
	}

	function kuist_lightbox_check_navigation() {
		if ( kuist_lightbox_swiper.activeIndex == 0 ) {
			kuist_lightbox_prev_btn_closing();
		} else {
			$( '.kuist-lightbox-prev' ).show();
			$( '.kuist-lightbox-prev' ).text( kuist_lightbox_swiper.activeIndex );
		}
		if ( kuist_lightbox_swiper.activeIndex == $( '.kuist-lightbox-swiper' ).find( '.swiper-slide ' ).length - 1 ) {
			kuist_lightbox_next_btn_closing();
		} else {
			$( '.kuist-lightbox-next' ).show();
			$( '.kuist-lightbox-next' ).text( kuist_lightbox_swiper.activeIndex + 2 );
		}
		series_first_click = false;
	}

	function kuist_set_lightbox_all_images_pos() {
		$( '.kuist-lightbox-swiper .swiper-slide img' ).each( function() {
			kuist_set_lightbox_active_image_pos( kuist_get_miw, kuist_get_mih, this );
		} );
	}

	function kuist_set_lightbox_active_image_pos( miw, mih, obj ) {
		if ( $( window ).height() <= mih ) {
			$( obj ).css( { 'width': 'auto', 'height': $( window ).height() } );
		} else {
			$( obj ).css( { 'width': 'auto', 'height': 'auto' } );
		}
		$( obj ).css( { 'max-width': miw, 'max-height': mih } );
		$( obj ).css( { 'top': $( window ).height()/2 - $( obj ).height()/2, 'left': $( window ).width()/2 - $( obj ).width()/2 } );
		if ( kuist_lightbox_lazy ) {
			$( '.swiper-lazy-preloader' ).css( { 'top': $( window ).height()/2, 'left': $( window ).width()/2 } );
		}
	}

	function kuist_set_lightbox_active_image_pos_wo_lazy() {
		$( '.kuist-lightbox-swiper .swiper-slide-active img' ).one( 'load', function() {
			kuist_set_lightbox_active_image_pos( kuist_get_miw, kuist_get_mih, this );
		}).each( function() {
			if ( this.complete ) { $( this ).load(); }
		});
	}

	// Controls
	$( '.kuist-lightbox-close' ).on( 'click', kuist_lightbox_closing );
	$( '.kuist-lightbox-prev' ).on( 'click', function() { kuist_lightbox_swiper.slidePrev(); } );
	$( '.kuist-lightbox-next' ).on( 'click', function() { kuist_lightbox_swiper.slideNext(); } );

	document.addEventListener( 'keyup', function( event ) {
		if ( $( '#kuist-lightbox' ).hasClass( 'kl-opened' ) ) {
			if ( event.which == 27 ) {
				//ESCAPE
				kuist_lightbox_closing();
			} else if ( event.which == 37 ) {
				//LEFT
				kuist_lightbox_swiper.slidePrev();
			} else if ( event.which == 39 ) {
				//RIGHT
				kuist_lightbox_swiper.slideNext();
			}
		}
	} );
	/* */

	/* Portfolio Series */
	var current_series = '';
	var current_title = '';
	var current_client = '';
	var current_agency = '';
	var current_photographer = '';
	var current_retoucher = '';
	var current_artist = '';
	var current_makeup = '';
	var current_date = '';
	var current_other = '';
	var preload_img_array = [];
	var dragger_warning = true;
	var dwint = 0;
	var dw_count = 0;

	if ( $( '.swiper-container' )[0] ) {

		var kuist_swiper = new Swiper( '.swiper-container', {
			roundLengths: true,
			autoplay: false,
			slidesPerView: 'auto',
      spaceBetween: 20,
			watchOverflow: true,
		} );

	}

	function kuist_preload_image( imgArray ) {
		$( imgArray ).each( function() {
			$( '<img>' ).attr( 'src', this ).load( function() {
				$( '.kuist-img-preloader' ).css( 'display', 'block' );
				if ( this.complete ) {
					//Completed
					$( '.kuist-img-preloader' ).css( 'display', 'none' );
					kuist_lightbox_opening();
					kuist_lightbox_swiper.slideTo( series_data_order );
					if ( series_first_click ) { kuist_lightbox_check_navigation(); }
					if ( !kuist_lightbox_lazy ) { kuist_set_lightbox_active_image_pos_wo_lazy(); }
				}
			});
		});
	}

	function kuist_series_bind_click() {
		$( '.series-swiper .swiper-slide' ).unbind().on( 'click', function() {
			series_first_click = true;

			current_series = $( this ).parent().attr( 'data-series' );
			current_title = $( this ).parent().attr( 'data-title' );
			current_client = $( this ).parent().attr( 'data-client' );
			current_agency = $( this ).parent().attr( 'data-agency' );
			current_photographer = $( this ).parent().attr( 'data-photographer' );
			current_retoucher = $( this ).parent().attr( 'data-retoucher' );
			current_artist = $( this ).parent().attr( 'data-artist' );
			current_makeup = $( this ).parent().attr( 'data-makeup' );
			current_date = $( this ).parent().attr( 'data-date' );
			current_other = $( this ).parent().attr( 'data-other' );

			kuist_attach_lighbox_series( current_series );
			kuist_lightbox_swiper.update();
			series_data_order = $( this ).find( 'img' ).attr( 'data-order' );
			$( '.kuist-img-preloader' ).css( 'display', 'block' );
			preload_img_array = [ $( this ).find( 'img' ).attr( 'data-lightbox-image' ) ];
			kuist_preload_image( preload_img_array );
			$( '#kuist-mask' ).removeClass( 'kuist-mask-hidden' ).addClass( 'kuist-mask-visible' );
			$( '.drag-notifier' ).css( 'opacity', 0 );
		} );
		$( '.swiper-slide.kuist-title' ).unbind();

		$( '.series-swiper .swiper-container' ).unbind().on( 'mouseover', function() {
			if ( dragger_warning && $( window ).width() > 640 ) {
				var total_width = 0;
				var total_slides = 0;
				$( this ).find( '.swiper-slide' ).each( function() {
					total_slides ++;
					total_width += $( this ).width();
				} );
				total_width += 85;
				total_width += (total_slides - 2) * 20;
				if ( total_width > $( window ).width() ) {
					dw_count += 1;
					if ( dw_count < 30 ) {
						$( this ).find( '.drag-notifier' ).css( 'opacity', 1 );
						clearInterval( dwint );
						dwint = setInterval( kuist_remove_dragger_warning, 3000 );
					}
				}
			}
			$( this ).find( '.kuist-title-inner' ).addClass( 'kti-hover');
			$( this ).find( '.kuist-letter' ).addClass( 'kl-hover');
		} ).on( 'mouseout', function() {
			$( '.drag-notifier' ).css( 'opacity', 0 );
			$( this ).find( '.kuist-title-inner' ).removeClass( 'kti-hover');
			$( this ).find( '.kuist-letter' ).removeClass( 'kl-hover');
		} );

	}

	function kuist_remove_dragger_warning() {
		clearInterval( dwint );
		$( '.drag-notifier' ).css( 'display', 'none' );
		dragger_warning = false;
	}

	function kuist_attach_lighbox_series( series ) {
		$( '.kuist-lightbox-swiper .swiper-wrapper' ).empty();
		$( '.swiper-container' ).find( '[data-series=' + series + '] img' ).each( function() {
			kuist_lightbox_image_cap = '';
			if ( $( this ).attr( 'data-caption' ) ) {
				kuist_lightbox_image_cap = '<div class="kuist-lightbox-caption">' + $( this ).attr( 'data-caption' ) + '</div>';
			}
			$( '.kuist-lightbox-swiper .swiper-wrapper' ).append( '<div class="swiper-slide"><img ' + kuist_lightbox_datasrc + 'src="' + $( this ).attr( 'data-lightbox-image' ) + '" class="' + kuist_lightbox_imgclass + '" alt="kuist-lightbox-image-' + series + '">' + kuist_lightbox_image_cap + kuist_lightbox_preloader + '</div>' );
		});
		$( '.kuist-lightbox-title' ).text( current_title );
		$( '.kuist-lightbox-info' ).empty();
		if ( current_client ) { $( '.kuist-lightbox-info' ).append( '<span class="l-info"><span class="l-info-hdr">' + $( '#l_hdr_client' ).html() + '</span>' + current_client + '</span>' ); }
		if ( current_agency ) { $( '.kuist-lightbox-info' ).append( '<span class="l-info"><span class="l-info-hdr">' + $( '#l_hdr_agency' ).html() + '</span>' + current_agency + '</span>' ); }
		if ( current_photographer ) { $( '.kuist-lightbox-info' ).append( '<span class="l-info"><span class="l-info-hdr">' + $( '#l_hdr_photographer' ).html() + '</span>' + current_photographer + '</span>' ); }
		if ( current_retoucher ) { $( '.kuist-lightbox-info' ).append( '<span class="l-info"><span class="l-info-hdr">' + $( '#l_hdr_retoucher' ).html() + '</span>' + current_retoucher + '</span>' ); }
		if ( current_artist ) { $( '.kuist-lightbox-info' ).append( '<span class="l-info"><span class="l-info-hdr">' + $( '#l_hdr_artist' ).html() + '</span>' + current_artist + '</span>' ); }
		if ( current_makeup ) { $( '.kuist-lightbox-info' ).append( '<span class="l-info"><span class="l-info-hdr">' + $( '#l_hdr_makeup' ).html() + '</span>' + current_makeup + '</span>' ); }
		if ( current_date ) { $( '.kuist-lightbox-info' ).append( '<span class="l-info"><span class="l-info-hdr">' + $( '#l_hdr_date' ).html() + '</span>' + current_date + '</span>' ); }
		if ( current_other ) { $( '.kuist-lightbox-info' ).append( '<span class="l-info"><span class="l-info-hdr">' + $( '#l_hdr_other' ).html() + '</span>' + current_other + '</span>' ); }
	}

	kuist_series_bind_click();

	//Load More Click Event
	var loadmore_int = 0;
	var containers_length = 0;

	$( '.kuist_loadmore' ).on( 'click', function() {
		containers_length = $( '.swiper-container' ).length;
		clearInterval( loadmore_int );
		loadmore_int = setInterval( kuist_check_loadmore_complete, 50 );
	} );

	function kuist_check_loadmore_complete() {
		if ( $( '.swiper-container' ).length > containers_length ) {
			clearInterval( loadmore_int );
			kuist_series_bind_click();
			containers_length = $( '.swiper-container' ).length;
		}
	}
	/* */

	/* Visible/Hidden Functions & Animations */
	function kuist_lightbox_opening() {
		kuist_show_mask_1000();
		clearInterval( animInt );
		animInt = setInterval( kuist_lightbox_visible, 1000 );
		$( '#kuist-lightbox' ).css( 'margin-top', 0 );
		$( 'body, .kuist-categories-icon' ).css( 'margin-top', $( window ).height() + 50 );
		$( '.mobile-header' ).css( 'margin-top', -100 );
		kuist_set_lightbox_all_images_pos();
		kuist_lightbox_check_first_navigation();
	}

	function kuist_lightbox_closing() {
		kuist_show_mask_1000();
		clearInterval( animInt );
		animInt = setInterval( kuist_lightbox_hidden, 1000 );
		$( '#kuist-lightbox' ).css( 'margin-top', -$( window ).height() - 500 );
		$( '#kuist-lightbox' ).removeClass( 'kl-opened' );
		$( 'body, .mobile-header, .kuist-categories-icon' ).css( 'margin-top', 0 );
	}

	function kuist_lightbox_visible() {
		clearInterval( animInt );
		$( '#kuist-lightbox' ).addClass( 'kl-opened' );
	}

	function kuist_lightbox_hidden() {
		clearInterval( animInt );
		$( '#kuist-lightbox' ).css( 'margin-top', -2800 );
	}

	function kuist_lightbox_prev_btn_closing() {
		clearInterval( animInt2 );
		animInt2 = setInterval( kuist_lightbox_prev_btn_hidden, 300 );
	}

	function kuist_lightbox_prev_btn_hidden() {
		clearInterval( animInt2 );
		$( '.kuist-lightbox-prev' ).hide();
	}

	function kuist_lightbox_next_btn_closing() {
		clearInterval( animInt2 );
		animInt2 = setInterval( kuist_lightbox_next_btn_hidden, 300 );
	}

	function kuist_lightbox_next_btn_hidden() {
		clearInterval( animInt2 );
		$( '.kuist-lightbox-next' ).hide();
	}

	function kuist_show_mask_1000() {
		$( '#kuist-mask' ).removeClass( 'kuist-mask-hidden' ).addClass( 'kuist-mask-visible' );
		clearInterval( maskInt );
		maskInt = setInterval( kuist_hide_mask, 1000 );
	}

	function kuist_hide_mask() {
		clearInterval( maskInt );
		$( '#kuist-mask' ).removeClass( 'kuist-mask-visible' ).addClass( 'kuist-mask-hidden' );
	}
	/* */

	/* Body Mouse Move & Click */
	$( 'body' ).on( 'mousemove', function( event ) {
		if ( dragger_warning ) {
			if ( event.pageX > $( window ).width() - 120 ) {
				$( '.drag-notifier' ).css( 'opacity', 0 );
			}
		}

		if ( $( window ).width() > 640 ) {
			$( '.kuist-img-preloader' ).css( { 'top': event.pageY - $( document ).scrollTop() + 30, 'left': event.pageX + 35 } );
		} else {
			$( '.kuist-img-preloader' ).css( { 'top': 115, 'left': 25 } );
		}
	} );
	/* */

	/* on Resize */
	function kuist_resizing() {
		kuist_set_submenu_positions();
		kuist_set_lightbox_all_images_pos();
		kuist_blog_item_woi_bg_height();
	}
	$( window ).on( 'resize', kuist_resizing );
	/* */

	/* on Scroll */
	$( window ).on( 'scroll', function() {
		//
	} );
	/* */

	/* END */

} );
