jQuery( document ).ready( function( $ ) {

  "use strict";

  /* START */

  var file_frame, attachment, selection, listIndex, term_change_image, term_change, term_remove, term_caption, index, currently_selected, that;
  var currently_added = [];

  // Add
  $( '#flexport-gallery-metabox' ).on( 'click', 'a.flexport-button-gallery-add', function( e ) {

    e.preventDefault();
    flexport_setFileFrame( $( this ), 'add' );

    file_frame.on( 'open', function() {

      selection = file_frame.state().get( 'selection' );
      currently_selected = [];

      $( '.flexport-image-val' ).each( function() {
        attachment = wp.media.attachment( $( this ).val() );
        selection.add( attachment ? [ attachment ] : [] );
        currently_selected.push( $( this ).val() );
      } );

      currently_added = currently_selected;

    } );

    file_frame.on( 'select', function() {

      listIndex = $( '#flexport-gallery-metabox-list li' ).index( $( '#flexport-gallery-metabox-list li:last' ) ),
      selection = file_frame.state().get( 'selection' );
      term_change_image = $( '.flexport-button-gallery-add' ).attr( 'data-js-term-change-image' );
      term_change = $( '.flexport-button-gallery-add' ).attr( 'data-js-term-change' );
      term_remove = $( '.flexport-button-gallery-add' ).attr( 'data-js-term-remove' );
      term_caption = $( '.flexport-button-gallery-add' ).attr( 'data-js-term-caption' );

      selection.map( function( attachment, i ) {

        attachment = attachment.toJSON(),
        index = listIndex + ( i + 1 );

        if ( currently_added.length == 0 ) {

          $( '#flexport-gallery-metabox-list' ).append( '<li><input class="flexport-image-val" type="hidden" name="flexport_gallery_id[' + index + ']" value="' + attachment.id + '"><img class="flexport-image-preview" src="' + attachment.sizes.thumbnail.url + '"><a class="flexport-button-change-image button button-small" href="#" data-uploader-title="' + term_change_image + '" data-uploader-button-text="' + term_change_image + '">' + term_change + '</a><a class="flexport-button-remove-image button button-small" href="#">' + term_remove + '</a><input type="text" name="flexport_caption_id[' + index + ']" class="widefat flexport-image-caption" placeholder="' + term_caption + '" value="' + attachment.caption + '" disabled></li>' );

          currently_added.push( attachment.id );

        } else {

          if ( currently_added.indexOf( String( attachment.id ) ) == '-1' ) {

            $( '#flexport-gallery-metabox-list' ).append( '<li><input class="flexport-image-val" type="hidden" name="flexport_gallery_id[' + index + ']" value="' + attachment.id + '"><img class="flexport-image-preview" src="' + attachment.sizes.thumbnail.url + '"><a class="flexport-button-change-image button button-small" href="#" data-uploader-title="' + term_change_image + '" data-uploader-button-text="' + term_change_image + '">' + term_change + '</a><a class="flexport-button-remove-image button button-small" href="#">' + term_remove + '</a><input type="text" name="flexport_caption_id[' + index + ']" class="widefat flexport-image-caption" placeholder="' + term_caption + '" value="' + attachment.caption + '" disabled></li>' );

            currently_added.push( attachment.id );

          }

        }

      } );

      flexport_resetIndex();
      flexport_checkRemoveAll();

    } );

    flexport_makeSortable();
    file_frame.open();

  } );

  // Change
  $( '#flexport-gallery-metabox' ).on( 'click', 'a.flexport-button-change-image', function( e ) {

    e.preventDefault();
    that = $( this );
    flexport_setFileFrame( $( this ), false );

    file_frame.on( 'open', function() {

      selection = file_frame.state().get( 'selection' );
      attachment = wp.media.attachment( that.parent().find( 'input:hidden' ).val() );
      selection.add( attachment ? [ attachment ] : [] );

    } );

    file_frame.on( 'select', function() {

      attachment = file_frame.state().get( 'selection' ).first().toJSON();
      that.parent().find( 'input:hidden' ).attr( 'value', attachment.id );
      that.parent().find( 'img.flexport-image-preview' ).attr( 'src', attachment.sizes.thumbnail.url );
      that.parent().find( 'input.flexport-image-caption' ).val( attachment.caption );

    } );

    file_frame.open();

  } );

  // Remove
  $( '#flexport-gallery-metabox' ).on( 'click', 'a.flexport-button-remove-image', function( e ) {

    e.preventDefault();
    index = currently_added.indexOf( $( this ).parent().find( '.flexport-image-val' ).val() );

    if ( index > -1 ) {
      currently_added.splice( index, 1 );
    }

    $( this ).parents( 'li' ).remove();
    flexport_resetIndex();
    flexport_checkRemoveAll();

  } );

  // Remove All
  $( '#flexport-gallery-metabox' ).on( 'click', 'a.flexport-button-remove-all', function( e ) {

    e.preventDefault();
    $( '#flexport-gallery-metabox-list li' ).remove();
    currently_added = [];
    flexport_resetIndex();
    flexport_checkRemoveAll();

  } );

  // Functions
  function flexport_setFileFrame( obj, mul ) {

		if ( file_frame ) {
			file_frame.close();
		}

		file_frame = wp.media.frames.file_frame = wp.media( {
			title: obj.data( 'uploader-title' ),
			button: {
				text: obj.data( 'uploader-button-text' ),
			},
			multiple: mul
		} );

	}

  function flexport_checkRemoveAll() {

    if ( $( '#flexport-gallery-metabox-list li' ).length > 0 ) {
      flexport_showRemoveAll();
    } else {
      flexport_hideRemoveAll();
    }

  }

  function flexport_showRemoveAll() {
    $( '#flexport-gallery-metabox a.flexport-button-remove-all' ).css( 'visibility', 'visible' );
  }

  function flexport_hideRemoveAll() {
    $( '#flexport-gallery-metabox a.flexport-button-remove-all' ).css( 'visibility', 'hidden' );
  }

  function flexport_resetIndex() {

    $( '#flexport-gallery-metabox-list li' ).each( function( i ) {
      $( this ).find( 'input:hidden' ).attr( 'name', 'flexport_gallery_id[' + i + ']' );
    } );

  }

  function flexport_makeSortable() {

    $( '#flexport-gallery-metabox-list' ).sortable( {
      opacity: 1,
      stop: function() {
        flexport_resetIndex();
      }
    } );

  }

  // Launch
  flexport_checkRemoveAll();
  flexport_makeSortable();

  /* END */

} );
